// A. Sints
#pragma once

#include "afxcmn.h"
#include "afxwin.h"

// input
#include "SInput.h"

// ffmpeg
#include "FFMPEGCapture.h"


// extract
#include "Extract.h"


// CAdjustmentsDlg dialog
class CAdjustmentsDlg : public CDialog, public CExtract {
	DECLARE_DYNAMIC( CAdjustmentsDlg )

public:

	// std ctor
	CAdjustmentsDlg( CWnd * _pParent = NULL )
		: CDialog( CAdjustmentsDlg::IDD, _pParent ), m_pFFMPEGCapture( NULL ), m_pInput( NULL ), m_dwDNR( 0 ), m_iFlip( 0 ) {}

	// dtor
	virtual ~CAdjustmentsDlg();

	// Dialog Data
	enum { IDD = IDD_ADJUSTMENTS };

private:

	// DDX/DDV support
	virtual void DoDataExchange( CDataExchange * _pDX );

	// on init dlg
	virtual BOOL OnInitDialog();

	// on paint
	afx_msg void OnPaint();

	// on ok
	afx_msg void OnBnClickedOk() { OnOK(); }

	// hscroll
	afx_msg void OnHScroll( UINT _nSBCode, UINT _nPos, CScrollBar * _pScrollBar );

	// timer
	void OnTimer( UINT_PTR );

	// load video
	afx_msg void OnBnClickedLoad();

	// load video
	void Load( LPCTSTR _sVideoPath );

	// pre translate message
	BOOL PreTranslateMessage( MSG * _pMSG );

	// vertical flip selection change
	afx_msg void OnCbnSelchangeCombo1();

	// copy values to clipboard
	void CopyToClipBoard();


private:

	// sliders
	CSliderCtrl m_color_cr;
	CSliderCtrl m_color_mg;
	CSliderCtrl m_color_yb;
	CSliderCtrl m_brightness;
	CSliderCtrl m_contrast;
	CSliderCtrl m_saturation;
	CSliderCtrl m_dnr;
	CComboBox m_vflip;

	// dummy button for image placement
	CButton m_dummy;

	// bitmap bits
	unsigned char * m_lpBits;

	// bitmap handle
	HBITMAP m_hBmp;

	// bitmap device context
	CDC m_bmpDC;

	// FFMPEGCapture
	CString m_sVideoPath;
	CRect m_rctDraw;
	CSInput * m_pInput;
	CFFMPEGCapture * m_pFFMPEGCapture;
	DWORD m_dwPosition;

	// DNR
	DWORD m_dwDNR;

	// flip
	int m_iFlip;

	DECLARE_MESSAGE_MAP()
};
