// A. Sints
#pragma once

// Auto resize control
class CCtrlAuto sealed {
public:

	// ctor
	CCtrlAuto();

	// copy operator
	CCtrlAuto & operator=( const CCtrlAuto & _ref );
	// copy ctor
	CCtrlAuto( const CCtrlAuto & _ref ) { *this = _ref; }


public:

	// position
	enum eAnchor{ EA_FIXED, EA_FLOAT, EA_STATIC };

	// set object
	void SetObject( CWnd * _pObj,
		eAnchor _eTop = EA_FIXED,
		eAnchor _eLeft = EA_FIXED,
		eAnchor _eBottom = EA_FIXED,
		eAnchor _eRight = EA_FIXED );

	// build object pos
	void Build( HWND _hWnd );

	// resize object
	void Resize( CSize _currentSz );

	// top left limit
	bool TopLeftLimit( CPoint _tlL );

	// rect
	void SetOriginalRect( CRect _originalRect ) { m_originalRect = _originalRect; }
	CRect GetOriginalRect() { return m_originalRect; }
	CRect GetCurrentRect() { return m_currentRect; }

	// get object
	CWnd * GetObject() { return m_pObj; }


private:

	eAnchor m_eTop, m_eLeft, m_eBottom, m_eRight;
	CWnd * m_pObj;
	CRect m_originalRect;
	CRect m_currentRect;
	CSize m_originalWndSz;

	// CListCtrl object
	bool m_bIsListCtrl;
	int m_iColCount;
	int m_originalColWidth[ 256 ];
};



//----------------------------

// Auto control pool
class CCtrlAutoPool sealed {
public:

	// add object in pool
	void AddObject( CWnd * _pObj,
		CCtrlAuto::eAnchor _eTop = CCtrlAuto::EA_FIXED,
		CCtrlAuto::eAnchor _eLeft = CCtrlAuto::EA_FIXED,
		CCtrlAuto::eAnchor _eBottom = CCtrlAuto::EA_FIXED,
		CCtrlAuto::eAnchor _eRight = CCtrlAuto::EA_FIXED );

	// build pool objects pos
	void Build( HWND _hWnd );

	// resize pool objects
	void Resize( CSize _currentSz );

	// get object
	CCtrlAuto * GetObject( CWnd * _pObj );


private:

	// get top left limit of an object
	CPoint _GetTopLeftLimit( CCtrlAuto _obj );

	// auto control pool
	CList< CCtrlAuto > m_vPool;
};