// A. Sints
#include "stdafx.h"
#include "Stuka.h"
#include "OutputDlg.h"


IMPLEMENT_DYNAMIC( COutputDlg, CDialog )

BEGIN_MESSAGE_MAP( COutputDlg, CDialog )
	ON_WM_PAINT()
END_MESSAGE_MAP()


// dtor
COutputDlg::~COutputDlg() {

	// delete bitmap
	DeleteObject( m_hBmp );
}



// on init dlg
BOOL COutputDlg::OnInitDialog() {

	// call parent
	CDialog::OnInitDialog();

	// get dummy rect
	GetClientRect( &m_rctDraw );

	// create bitmap info header	
	BITMAPINFO bmpInfo;
	ZeroMemory( &bmpInfo, sizeof( BITMAPINFO ) );
	bmpInfo.bmiHeader.biSize = sizeof( BITMAPINFOHEADER );
	bmpInfo.bmiHeader.biBitCount = 32;
	bmpInfo.bmiHeader.biWidth = m_rctDraw.Width();
	bmpInfo.bmiHeader.biHeight = m_rctDraw.Height();
	bmpInfo.bmiHeader.biPlanes = 1;
	bmpInfo.bmiHeader.biSizeImage = m_rctDraw.Height() * m_rctDraw.Width() * 4;

	// create DIBSection
	m_hBmp = CreateDIBSection( NULL, &bmpInfo, DIB_RGB_COLORS, ( void ** )&( m_pu8Dst ), NULL, 0 );

	// create bmp device context
	m_bmpDC.CreateCompatibleDC( GetDC() );
	m_bmpDC.SelectObject( m_hBmp );

	// no focus
	return TRUE;
}


// output bitmap
void COutputDlg::Output( const unsigned char * _pu8Src, const DWORD & _dwSrcWidth, const DWORD & _dwSrcHeight ) {

	CSingleLock( &m_mtxBmp, TRUE );

	// copy
	DWORD dwDstWidth = m_rctDraw.Width();
	DWORD dwDstHeight = m_rctDraw.Height();
	DWORD dwSrcWidthM1 = _dwSrcWidth - 1;
	DWORD dwSrcHeightM1 = _dwSrcHeight - 1;
	DWORD dwDstWidthM1 = dwDstWidth - 1;
	DWORD dwDstHeightM1 = dwDstHeight - 1;
	DWORD dwYW, dwSYW, dwSrcOffset, dstX;
	for( DWORD dstY = 0; dstY < dwDstHeight; dstY++ ) {
		dwYW = dstY * dwDstWidth;
		dwSYW = ( dstY * dwSrcHeightM1 / dwDstHeightM1 ) * _dwSrcWidth;
		for( dstX = 0; dstX < dwDstWidth; dstX++ ) {
			dwSrcOffset = ( dwSYW + ( dstX * dwSrcWidthM1 / dwDstWidthM1 ) ) * 3;
			( ( ( DWORD * ) m_pu8Dst )[ dwYW + dstX ] ) = 0xFF000000 | ( DWORD( _pu8Src[ dwSrcOffset + 2 ] ) << 16 ) | ( DWORD( _pu8Src[ dwSrcOffset + 1 ] ) << 8 ) | _pu8Src[ dwSrcOffset ];
		}
	}

	InvalidateRect( m_rctDraw, FALSE );
}


// reset window
void COutputDlg::Reset() {

	CSingleLock( &m_mtxBmp, TRUE );

	// reset
	memset( m_pu8Dst, 0, m_rctDraw.Width() * m_rctDraw.Height() * 4 );
	InvalidateRect( m_rctDraw, FALSE );
}


// on paint
void COutputDlg::OnPaint() {

	CSingleLock( &m_mtxBmp, TRUE );

	// iconic
	if( IsIconic() )
		return;

	// current dc
	CPaintDC dc( this );

	// draw bitmap to Dlg
	dc.BitBlt( 0, 0, m_rctDraw.Width(), m_rctDraw.Height(), &m_bmpDC, 0, 0, SRCCOPY );

	// parent call
	CDialog::OnPaint();
}