// A. Sints
#pragma once


// script
#include "Script.h"

// Viewport
#include "Viewport.h"

// display
#include "SMDisplay.h"

// forward
class COutputDlg;


// Stuka Project class
class CProject sealed : public CThread {
public:

	// dflt ctor
	CProject( LPCTSTR _sScriptPath, const COutputDlg & _rOutputDlg );

	// dtor
	~CProject();


public:

	// build project
	const bool Build();


private:

	// callback
	const bool Callback();


private:

	// get current time with precision as 1. sec
	const double _GetTime();

	// copy a bitmap
	void _BmpCopy( const HBITMAP & _hSrcBmp, const DWORD _dwSrcWidth, const DWORD _dwSrcHeight, unsigned char * _pu8Dst, const DWORD _dwDstWidth, const DWORD _dwOffsetX, const DWORD _dwOffsetY, const unsigned char * const _pRGBAdjust, const unsigned char & _u8Factor, const HBITMAP _hBmpOverlay = NULL, const unsigned char * const _pRGBAdjustOverlay = NULL );

	// draw line
	enum eLineType { LT_HORIZONTAL, LT_VERTICAL };
	void _DrawLine( const CPoint & _ptOrigin, const eLineType _eLineType, const DWORD _dwLenght, unsigned char * _pu8Dst, const DWORD _dwDstWidth, const DWORD _dwDstHeight, const DWORD _dwLineSize = 1  );

	// interpolate bitmap
	void _BmpInterpolate( HBITMAP & _rhSrcBmp, const CViewport & _rViewport, const CRect & _rctLayout, const DWORD & _dwFrame, const DWORD & _dwRFrame, DWORD _dwDiv );

	// highlight bitmap
	void _BmpHighlight( const HBITMAP & _rhSrcBmp, const CRect & _rctLayout, const DWORD _dwHighlight );

	// get cycle time
	const double _GetCycleTime( const CSMDisplay::eCycle & _reCycle, const double & _dMinCycleMs, const double & _dEachMeasureMs, const double & _dEvery3BeatMs, const double & _dEvery2BeatMs, const double & _dEachBeatMs, const double & _dEveryHalfBeatMs, const double & _dEveryQuarterBeatMs, const double & _dEveryEighthBeatMs );

	// draw text on bitmap
	void _BmpText( const HBITMAP & _rhSrcBmp, const CRect & _rctLayout, LPCTSTR _sText, UINT _uiFormat = DT_CENTER | DT_VCENTER );


private:
	
	// build script
	CScript m_script;

	// output dlg
	const COutputDlg & m_rOutputDlg;

	// text device context
	CDC m_textDC;
	CFont m_font;
};