// A. Sints
#pragma once

/*
display( "input_id or group_id", cycle ); // cycle: none, each_measure, each_beat, every_2_beats, every_3_beats
*/


// Stuka Script Marker Display
class CSMDisplay sealed {
public:

	// display cycle type
	enum eCycle {
		DC_NULL,
		DC_NONE,
		DC_EACHMEASURE,
		DC_EACHBEAT,
		DC_EVERY2BEATS,
		DC_EVERY3BEATS,
		DC_EVERYHALFBEAT,
		DC_EVERYQUARTERBEAT,
		DC_EVERYEIGHTHBEAT };


public:

	// dflt ctor
	CSMDisplay( LPCTSTR _sRefID, const eCycle _eCycle )
		: m_sRefID( _sRefID ), m_eCycle( _eCycle ) {}


public:

	// get refID
	const CString & GetRefID() const { return m_sRefID; }

	// get cycle type from string
	static const eCycle GetCycleType( const CString & _sCycle );

	// get current cycle
	const eCycle & GetCycle() const { return m_eCycle; }


private:

	// input or group ID reference
	const CString m_sRefID;

	// display cycle type
	const eCycle m_eCycle;
};