// A. Sints
#pragma once

// effect( type ); // effect: none, fade_in, fade_out, [strobe, cycle]

// displau
#include "SMDisplay.h"


// Stuka Script Marker Effect class
class CSMEffect sealed {
public:

	// marker effect
	enum eEffect{ ME_NULL, ME_NONE, ME_FADE_IN, ME_FADE_OUT, ME_STROBE };


public:

	// dflt ctor
	CSMEffect( const eEffect _eEffect = ME_NONE )
		: m_eEffect( _eEffect ), m_eStrobeCyle( CSMDisplay::DC_NULL ) {}

	// dtor
	~CSMEffect() {}


public:

	// get effect type from string
	static const eEffect GetEffectType( const CString & _sEffect );

	// set effect
	void SetEffect( const eEffect & _eEffect ) { m_eEffect = _eEffect; }

	// get effect
	const eEffect & GetEffect() const { return m_eEffect; }

	// set strobe cycle
	void SetStrobeCycle( const CSMDisplay::eCycle _eStrobeCyle ) { m_eStrobeCyle = _eStrobeCyle; }

	// get strobe cycle
	const CSMDisplay::eCycle & GetStrobeCycle() const { return m_eStrobeCyle; }


private:

	// effect type
	mutable eEffect m_eEffect;

	// strobe cycle
	CSMDisplay::eCycle m_eStrobeCyle;
};