// A. Sints
#include "stdafx.h"

#include "..\StukaDlg.h"
#include "SOverlay.h"


// parse script
const bool CSOverlay::Parse( const CString & _sScript ) {

	// capture
	int iStart = 0;
	CString sParams;
	if( ExtractCommand( _sScript, L"capture", sParams, iStart ) ) {

		int iParamStart = 0;
		CString sdwL, sdwT, sdwR, sdwB;
		if( !ExtractParam( sParams, sdwL, iParamStart ) ) {
			CStukaDlg::Output( L"Error (SOverlay): Failed to extract 'left'.\n" );
			return false;
		}
		if( !ExtractParam( sParams, sdwT, iParamStart ) ) {
			CStukaDlg::Output( L"Error (SOverlay): Failed to extract 'top'.\n" );
			return false;
		}
		if( !ExtractParam( sParams, sdwR, iParamStart ) ) {
			CStukaDlg::Output( L"Error (SOverlay): Failed to extract 'right'.\n" );
			return false;
		}
		if( !ExtractParam( sParams, sdwB, iParamStart ) ) {
			CStukaDlg::Output( L"Error (SOverlay): Failed to extract 'bottom'.\n" );
			return false;
		}
		// set capture rect
		m_rctCapture = CRect( _wtoi( sdwL.GetString() ), _wtoi( sdwT.GetString() ), _wtoi( sdwR.GetString() ), _wtoi( sdwB.GetString() ) );
	}

	// ok
	return true;
}



// validate script
const bool CSOverlay::Validate() {

	// if an ID is set loop count can't be 0
	if( !m_sID.IsEmpty() && m_dwLoopCount == 0 ) {
		CStukaDlg::Output( L"Error (SOverlay): Failed to validate script: overlay was set but loop count is incorrect.\n" );
		return false;
	}

	// ok
	return true;
}