// A. Sints
#pragma once

/*
overlay( "input_id", loop_count ) {
	capture( left, top, right, bottom );
}
*/

// extract
#include "Extract.h"


// Stuka Script Overlay class
class CSOverlay sealed : public CExtract {
public:

	// dflt ctor
	CSOverlay() : m_dwLoopCount( 0 ), m_rctCapture( 0, 0, 0, 0 ) {}

	// dtor
	~CSOverlay() {}


public:

	// set overlay values
	void SetOverlay( LPCTSTR _sID, const DWORD _dwLoopCount ) { m_sID = _sID; m_dwLoopCount = _dwLoopCount; }


public:

	// parse script
	const bool Parse( const CString & _sScript );

	// validate script
	const bool Validate();

	// get ID
	const CString & GetRefID() const { return m_sID; }

	// get loop count
	const DWORD & GetLoopCount() const { return m_dwLoopCount; }

	// get capture rect
	const CRect & GetCaptureRect() const { return m_rctCapture; }


private:

	// ref ID (can be empty)
	CString m_sID;

	// loop count
	DWORD m_dwLoopCount;

	// capture rect
	CRect m_rctCapture;
};