// A. Sints
#pragma once

#include "afxwin.h"
#include "afxmt.h"


// named thread
class CThread abstract : public CWinThread {
protected:

	// ctor
	CThread();

	// dtor
	virtual ~CThread() { Stop(); }


protected:

	// start the thread with an optional name and priority
	const bool Start( LPCTSTR _sName = L"<unnamed>", const int _nPriority = THREAD_PRIORITY_NORMAL );

	// stop the thread
	void Stop();

	// stopping ?
	const bool Stopping() const { return m_bStop; }


protected:

	// user callback to override
	virtual const bool Callback() = 0;


private:	// CWinThread

	BOOL InitInstance() { return TRUE; }
	int Run();


private:

	// stop order
	bool m_bStop;

	// stopped
	CEvent m_evtStopped;
};