// A. Sints
#include "stdafx.h"

#include "Viewport.h"

// Input
#include "SInput.h"


// dflt dtor
CViewport::~CViewport() {

	// when closing the viewport, reset adjustment table
	for( POSITION pos = m_lInputs.GetHeadPosition(); pos; )
		m_lInputs.GetNext( pos )->GetRGBAdjustment().ResetTable();
}


// cycle input
void CViewport::Cycle( const double _dCurrentTimeMs ) {

	// compute cycle count
	int iCycle = int( _dCurrentTimeMs / m_dCycleMs );
	iCycle = iCycle - ( ( iCycle / m_lInputs.GetCount() ) * m_lInputs.GetCount() );

	// search the good position
	int iCurrCycle = 0;
	for( m_lInputsPos = m_lInputs.GetHeadPosition(); m_lInputsPos; ) {
		if( iCurrCycle++ == iCycle )
			break;
		m_lInputs.GetNext( m_lInputsPos );
	}
}


// get intermediate bitmap bits
unsigned char * CViewport::GetIntermediateBmpBits( const DWORD _dwWidth, const DWORD _dwHeight, HBITMAP & _rhIntermediateBmp ) const {

	if( m_hIntermediateBmp == NULL ) {

		// create DIB section
		BITMAPINFO bmi;
		ZeroMemory( &bmi, sizeof( BITMAPINFO ) );
		bmi.bmiHeader.biSize = sizeof( BITMAPINFOHEADER );
		bmi.bmiHeader.biBitCount = 24;
		bmi.bmiHeader.biWidth = _dwWidth;
		bmi.bmiHeader.biHeight = _dwHeight;
		bmi.bmiHeader.biPlanes = 1;
		m_hIntermediateBmp = CreateDIBSection( NULL, &bmi, DIB_RGB_COLORS, NULL, NULL, 0 );

		// interpolated frame data
		GetObject( m_hIntermediateBmp, sizeof( BITMAP ), &m_IntermediateBmp );
	}

	// return bits
	_rhIntermediateBmp = m_hIntermediateBmp;
	return ( unsigned char * ) m_IntermediateBmp.bmBits;
}