// A. Sints
#pragma once


// ffwd
class CSInput;

// FFMPEG capture
#include "FFMPEGCapture.h"


// Viewport class
class CViewport sealed {
friend CList< CViewport >;
private:

	// private std ctor for CList only
	CViewport() : m_prctLayout( NULL ), m_hIntermediateBmp( NULL ), m_dwLastReleasedFrameIndex( 0 ) {}


public:

	// dflt ctor
	CViewport( const CString & _sRefID, const CRect & _rctLayout )
		: m_sRefID( _sRefID ), m_prctLayout( const_cast< CRect * >( &_rctLayout ) ), m_hIntermediateBmp( NULL ), m_dwLastReleasedFrameIndex( 0 )
		{ m_lInputsPos = m_lInputs.GetHeadPosition(); }

	// dflt dtor
	~CViewport();


public:

	// get ref ID
	const CString & GetRefID() const { return m_sRefID; }

	// get layout
	const CRect & GetLayout() const { return *m_prctLayout; }

	// get input list
	CList< CSInput * > & GetInputList() { return m_lInputs; }

	// get current input
	CSInput & GetCurrentInput() const { return *( m_lInputs.GetAt( m_lInputsPos ) ); }

	// set cycle time
	void SetCycle( const double _dCycleMs ) { m_dCycleMs = _dCycleMs; }

	// cycle input
	void Cycle( const double _dCurrentTimeMs );

	// set FFMPEGCapture
	void SetFFMPEGCapture( const CFFMPEGCapture & m_rFFMPEGCapture ) { m_pFFMPEGCapture = const_cast< CFFMPEGCapture * >( &m_rFFMPEGCapture ); }

	// release FFMPEGCapture
	void ReleaseFFMPEGCapture() { delete m_pFFMPEGCapture; m_pFFMPEGCapture = NULL; }

	// get FFMPEGCapture
	CFFMPEGCapture & GetFFMPEGCapture() const { return *m_pFFMPEGCapture; }

	// get intermediate bitmap bits
	unsigned char * GetIntermediateBmpBits( const DWORD _dwWidth, const DWORD _dwHeight, HBITMAP & _rhIntermediateBmp ) const;

	// last released frame
	const DWORD & GetLastReleasedFrameIndex() const { return m_dwLastReleasedFrameIndex; }
	void SetLastReleasedFrameIndex( const DWORD & _dwFrame ) const { m_dwLastReleasedFrameIndex = _dwFrame; }
	

private:

	// ref ID
	const CString m_sRefID;

	// layout rectangle
	CRect * m_prctLayout;

	// inputs
	CList< CSInput * > m_lInputs;

	// current input position
	POSITION m_lInputsPos;

	// cycle time ms
	double m_dCycleMs;

	// FFPEGCapture unit
	CFFMPEGCapture * m_pFFMPEGCapture;

	// intermediate bitmap
	mutable HBITMAP m_hIntermediateBmp;
	mutable BITMAP m_IntermediateBmp;

	// last released frame index
	mutable DWORD m_dwLastReleasedFrameIndex;
};